;**********************************************************************
; Image Skin Demo, written by Dan Ferguson (Zcoder)
; June 9th 2003 
; for other example's on Win32 Programming.
; if you have any questions contact me at: zcoder@email.com
; 
;**********************************************************************
      .386
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************

;     include files
;     ~~~~~~~~~~~~~
      include \Altra32\INCLUDE\windows.inc
      include \Altra32\INCLUDE\user32.inc
      include \Altra32\INCLUDE\kernel32.inc
      include \Altra32\INCLUDE\gdi32.inc      


;     libraries
;     ~~~~~~~~~

      includelib \Altra32\LIB\user32.lib
      includelib \Altra32\LIB\kernel32.lib
      includelib \Altra32\LIB\gdi32.lib      


      

;**********************************************************************

        ;=================
        ; Local prototypes
        ;=================
        WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
        Do_MakeRegion PROTO :DWORD,:DWORD,:DWORD,:DWORD
        ImageButProcs1 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        ImageButProcEx PROTO :DWORD,:DWORD,:DWORD,:DWORD
        ImageButtonEx PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        ImageButtonsEx PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        wsprintfA PROTO C :DWORD,:VARARG
        wsprintf equ 

      ;**************************************
      ; A few macros to make our life easy.
      ;**************************************

      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM
      
;**********************************************************************
; Some data to start us off right.
;**********************************************************************
    .data
        szDisplayName db "Simple Skin Demo",0
        szClose       db "Close",0
        szOk          db "OK",0
        ImageBack     db "face.bmp",0
        Buttonup      db "lbutton.bmp",0
        ButtonDwn     db "lbutton1.bmp",0
        ButtonHov     db "hbutton.bmp",0
        Minbut        db "minbut.bmp",0
        Minbut1       db "minbut1.bmp",0
        Closebut      db "closebut.bmp",0
        Closebut1     db "closebut1.bmp",0
        hBackImage    dd 0
        CommandLine   dd 0
        hWnd          dd 0
        hInstance     dd 0
        hIcon         dd 0
        Wwd1          dd 466      
        Wht1          dd 276      


;**********************************************************************
; The simple start of our program. this should be well known to all.
;**********************************************************************
.code

start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax
      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax

;**********************************************************************
; Create our main program window and load the background image and set
; it to our windows background, then later we set the images region's
; so we can skin this nasty Microsoft window look.
;**********************************************************************
WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

      ;====================
      ; Put LOCALs on stack
      ;====================

      LOCAL wc   :WNDCLASSEX
      LOCAL msg  :MSG
      LOCAL hImage   :DWORD
      ;==================================================
      ; Fill WNDCLASSEX structure with required variables
      ;==================================================

      invoke LoadIcon,hInst,500    ; icon ID
      mov hIcon, eax
      szText szClassName,"SimpleWin_Class"
      mov wc.cbSize,         sizeof WNDCLASSEX
      mov wc.style,          CS_HREDRAW or CS_VREDRAW \
                             or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,    offset WndProc
      mov wc.cbClsExtra,     NULL
      mov wc.cbWndExtra,     NULL
      m2m wc.hInstance,      hInst
      invoke LoadImage,hInst,addr ImageBack,IMAGE_BITMAP,Wwd1,Wht1,LR_LOADFROMFILE
      mov hBackImage,eax
      invoke CreatePatternBrush,eax
      mov wc.hbrBackground,  eax
      mov wc.lpszMenuName,   NULL
      mov wc.lpszClassName,  offset szClassName
      m2m wc.hIcon,          hIcon
      invoke LoadCursor,NULL,IDC_ARROW
      mov wc.hCursor,        eax
      m2m wc.hIconSm,        hIcon

      invoke RegisterClassEx, ADDR wc
      
      invoke CreateWindowEx,0,
                            ADDR szClassName,
                            ADDR szDisplayName,
                            WS_POPUP,
                            10,10,Wwd1,Wht1,
                            NULL,NULL,
                            hInst,NULL
      mov   hWnd,eax

      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain endp

;**********************************************************************
; 
;**********************************************************************

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

             LOCAL  hDC           :DWORD
             LOCAL  rect          :RECT
             LOCAL  Xsize         :DWORD
             LOCAL  Ysize         :DWORD
             LOCAL  hMemDC        :DWORD
             LOCAL  hBmp          :DWORD
             LOCAL  hOldObject    :DWORD
             LOCAL  hImage        :DWORD

    .if uMsg == WM_CREATE
        invoke Do_MakeRegion,hWin,hBackImage,Wwd1,Wht1
        invoke GetClientRect,hWin,addr rect
        sub [rect.bottom],50
        sub [rect.right],258
        szText szExit,"Exit"
        invoke ImageButtonsEx,hWin,380,230,77,27,addr Buttonup,addr ButtonDwn,addr ButtonHov,1000,1,addr szClose 
        invoke ImageButtonEx,hWin,416,9,18,19,addr Minbut1,addr Minbut1,addr Minbut,1001,1        
        invoke ImageButtonEx,hWin,434,9,17,18,addr Closebut1,addr Closebut1,addr Closebut,1002,1
        invoke ImageButtonsEx,hWin,303,230,77,27,addr Buttonup,addr ButtonDwn,addr ButtonHov,1003,1,addr szOk 

    .elseif uMsg == WM_LBUTTONDOWN
        invoke SendMessage,hWin,WM_NCLBUTTONDOWN,HTCAPTION,0
    
     .elseif uMsg == WM_PAINT
        invoke GetDC,hWin
        mov [hDC],eax
        invoke GetClientRect,hWin,addr rect
        mov eax,[rect.top]
        add eax,25
        add [rect.top],8
        mov [rect.bottom],eax
        add [rect.left],40
        mov eax,[rect.right]
        sub eax,[rect.left]
        mov [Xsize],eax
        mov eax,[rect.bottom]
        sub eax,[rect.top]
        mov [Ysize],eax
        invoke CreateCompatibleBitmap,hDC,Xsize,Ysize
        mov [hBmp],eax
        invoke CreateCompatibleDC,hDC
        mov [hMemDC],eax
        invoke SelectObject,hMemDC,hBmp
        mov [hOldObject],eax
        invoke SetBkMode,hDC,TRANSPARENT
        invoke SetTextColor,hDC,0FFFFFFh
        invoke DrawText,hDC,addr szDisplayName,15,addr rect,DT_LEFT
        add [rect.left],1
        add [rect.top],1
        invoke SetTextColor,hDC,0h
        invoke DrawText,hDC,addr szDisplayName,15,addr rect,DT_LEFT
        invoke DeleteObject,hOldObject
        invoke DeleteObject,hBmp
        invoke DeleteDC,hMemDC
        invoke ReleaseDC,hWin,hDC        

       
    .elseif uMsg == WM_COMMAND
        .if wParam == 1000
        invoke PostQuitMessage,NULL
        return 0 
    .endif
        .if wParam == 1002
        invoke PostQuitMessage,NULL
        return 0 
    .endif

    .endif
    
    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp
.data
        Win_Class          db "STATIC",0        
        BmpButton_Class   db "BmpButtonClass",0
        TME               TRACKMOUSEEVENT<>

.code

;*******************************************************************
; This procedure creates a three image button class. a class where
; the button has a normal state, and when the mouse is hovering
; over it, it changes images, and when you click on it it changes
; to the third image, the click image.
;*******************************************************************
ImageButtonsEx proc hWin:DWORD,Xpos:DWORD,Ypos:DWORD,Wwd:DWORD,Wht:DWORD,
                    Image1:DWORD,Image2:DWORD,Image3:DWORD,ID:DWORD,dwLoadFlg:DWORD,lpText:DWORD
             LOCAL hImageUp    :DWORD
             LOCAL hImageDwn   :DWORD
             LOCAL hImageOvr   :DWORD
             LOCAL hImage      :DWORD
             LOCAL hModule     :DWORD
             LOCAL Wwidth      :DWORD
             LOCAL Wheigth     :DWORD
             LOCAL hButnW      :DWORD
             LOCAL rect        :RECT
             LOCAL hDC         :DWORD
             LOCAL hMemDC      :DWORD
             LOCAL hOldObject  :DWORD
             LOCAL Xsize       :DWORD
             LOCAL Ysize       :DWORD
             LOCAL Tcount      :DWORD
             LOCAL WRct         :RECT
             LOCAL wc          :WNDCLASSEX
             LOCAL tm          :TEXTMETRIC
;*********************************************************************
; First we start by getting the Module handle of our main program.
; this part is not needed, but if you place it in a library you will
; need this, or you can use the GetParent API call. Sence this was
; pulled right out from my library it is here.
;*********************************************************************
             invoke GetModuleHandle,NULL
             mov hModule, eax
;*********************************************************************
; One of the params sent to this procedure is the load flag, what this 
; means is simple, if the flag is set it tells us to load the images
; from disk, which means that the params (Image1, Image2, Image3) are
; pointers to BITMAP NAMES and paths. if the flag is zero we load
; the images from resource. COOL hu??
;*********************************************************************
             .if dwLoadFlg == 1
             invoke LoadImage,hModule,Image1,IMAGE_BITMAP,Wwd,Wht,LR_LOADFROMFILE
             mov hImageUp, eax
             invoke LoadImage,hModule,Image2,IMAGE_BITMAP,Wwd,Wht,LR_LOADFROMFILE
             mov hImageDwn, eax
             invoke LoadImage,hModule,Image3,IMAGE_BITMAP,Wwd,Wht,LR_LOADFROMFILE
             mov hImageOvr, eax
             .else
             invoke LoadImage,hModule,Image1,IMAGE_BITMAP,Wwd,Wht,0
             mov hImageUp, eax
             invoke LoadImage,hModule,Image2,IMAGE_BITMAP,Wwd,Wht,0
             mov hImageDwn, eax
             invoke LoadImage,hModule,Image3,IMAGE_BITMAP,Wwd,Wht,0
             mov hImageOvr, eax
             .endif
;*************************************************************************************
; At this point we have loaded the three images, these images are blank and now we
; need to draw text on the images. each image get the same text that was pass to us
; thru lpText. but each button has a small difference to them as far as the text goes.
; we start out by building a rect of the size sent to use with Wwd and Wht so the 
; buttons will be the size we ask them to be, even if the actual images are larger
; or smaller.
;*************************************************************************************
        mov [rect.top],0
        mov [rect.left],0
        mov eax,[Wwd]
        mov [rect.right],eax
        mov [Xsize],eax
        mov eax,[Wht]
        mov [rect.bottom],eax
        mov [Ysize],eax
;**********************************************************************
; We are now going to create the three images we will build the first
; image button by getting a DC to our main window and then Create a
; Compatible DC from the main window, then we select the up image into
; this hMemDC so we can draw on it. we do this for each image. one at
; a time.
;**********************************************************************
        invoke GetDC,hWin
        mov [hDC],eax
        invoke CreateCompatibleDC,hDC
        mov [hMemDC],eax
        invoke SelectObject,hMemDC,hImageUp
        mov [hOldObject],eax
;*********************************************************************
; now lets figure the size of the rect area where we will draw the
; text, the text must be centered, and aligned in the button so lets
; get the text average width and times it by the char count of
; the text line, then subtract this from the width of the button
; then divide this in half, to get the right amount to add to
; the left side of the rect so the text will be drawn in the
; center of the button.       
;*********************************************************************
        invoke lstrlen,lpText
        mov [Tcount],eax
        invoke GetTextMetrics,hMemDC,addr tm
        mov eax,[tm.tmAveCharWidth]
        mov ecx,[Tcount]
        xor edx,edx
        mul ecx
        mov ecx,[Xsize]
        sub ecx,eax
        mov eax,ecx
        mov ecx,2
        div ecx
        add [rect.left],eax
;*********************************************************************
; Get the text height and subtract this from the height of the button
; then divide this in half to get the right value to add to the top
; so the text is center Horz.
;*********************************************************************
        mov eax,[tm.tmHeight]
        xor edx,edx
        mov ecx,[Ysize]
        sub ecx,eax
        mov eax,ecx
        mov ecx,2
        div ecx
        add [rect.top],eax
;**********************************************************************
; Now that the text rect is made, we can use it to draw on each buttons
; face, so we draw the text in white, then increase the rect's top and
; left by one pixel and draw the text in black, this creates the 
; illustion of imbosed text.
;**********************************************************************  
        invoke SetBkMode,hMemDC,TRANSPARENT
        invoke SetTextColor,hMemDC,0FFFFFFh
        invoke DrawText,hMemDC,lpText,Tcount,addr rect,DT_LEFT
        add [rect.left],1
        add [rect.top],1
        invoke SetTextColor,hMemDC,0h
        invoke DrawText,hMemDC,lpText,Tcount,addr rect,DT_LEFT
        dec [rect.left]
        dec [rect.top]
        invoke DeleteObject,hOldObject
        invoke DeleteDC,hMemDC
;********************************************************************
; Now we create another button image in memory and do just the same
; as above, but with RED in place of black, this will be our mouse
; hover button. otherwise it's the same as above.
;********************************************************************
        invoke CreateCompatibleDC,hDC
        mov [hMemDC],eax
        invoke SelectObject,hMemDC,hImageOvr
        mov [hOldObject],eax
        invoke SetBkMode,hMemDC,TRANSPARENT
        invoke SetTextColor,hMemDC,0FFFFFFh
        invoke lstrlen,lpText
        mov [Tcount],eax
        invoke DrawText,hMemDC,lpText,Tcount,addr rect,DT_LEFT
        add [rect.left],1
        add [rect.top],1
        invoke SetTextColor,hMemDC,00FFh
        invoke DrawText,hMemDC,lpText,Tcount,addr rect,DT_LEFT
        dec [rect.left]
        dec [rect.top]
        invoke DeleteObject,hOldObject
        invoke DeleteDC,hMemDC
;**********************************************************************
; Now we create another button image in memory and do just the same
; as the above two, but with black and white reversed,this button is
; simuler to the first button but the colors are reversed to create a
; sunkin text look. otherwise it's the same as above. this button
; will be our clicked button.
;**********************************************************************
        add [rect.top],1
        add [rect.left],1
        invoke CreateCompatibleDC,hDC
        mov [hMemDC],eax
        invoke SelectObject,hMemDC,hImageDwn
        mov [hOldObject],eax
        invoke SetBkMode,hMemDC,TRANSPARENT
        invoke SetTextColor,hMemDC,00h
        invoke lstrlen,lpText
        mov [Tcount],eax
        invoke DrawText,hMemDC,lpText,Tcount,addr rect,DT_LEFT
        add [rect.left],1
        add [rect.top],1
        invoke SetTextColor,hMemDC,0FFFFFFh
        invoke DrawText,hMemDC,lpText,Tcount,addr rect,DT_LEFT
        dec [rect.left]
        dec [rect.top]
        invoke DeleteObject,hOldObject
        invoke DeleteDC,hMemDC
        invoke ReleaseDC,hWin,hDC        
;**************************************************************************        
; Now that we created our three button images now we can create our 
; TRANSPARENT window class to set our buttons in. classing is easy
; as pie, yes I said class, and the class goes something like this.
;**************************************************************************
             mov wc.cbSize,         sizeof WNDCLASSEX
             mov wc.style,          CS_BYTEALIGNWINDOW
             mov wc.lpfnWndProc,    offset ImageButProcs1
             mov wc.cbClsExtra,     NULL
             mov wc.cbWndExtra,     20
             push hModule
             pop wc.hInstance
             mov wc.hbrBackground,  COLOR_BTNFACE+1
             mov wc.lpszMenuName,   NULL
             mov wc.lpszClassName,  offset BmpButton_Class
             mov wc.hIcon,          NULL
             invoke LoadCursor,NULL,IDC_ARROW
             mov wc.hCursor,        eax
             mov wc.hIconSm,        NULL

             invoke RegisterClassEx, ADDR wc

             invoke CreateWindowEx,WS_EX_TRANSPARENT,
                                   addr BmpButton_Class,NULL,
                                   WS_CHILD or WS_VISIBLE,
                                   Xpos,Ypos,100,100,hWin,ID,
                                   hModule,NULL

             mov hButnW, eax
;*************************************************************************
; We just created a TRANSPARENT window, now it is a class, so now lets
; store the handles of our images (up image, down image, over image) into 
; that all famouse extra window memory area for later use.
;*************************************************************************
             invoke SetWindowLong,hButnW,0,hImageUp
             invoke SetWindowLong,hButnW,4,hImageDwn
             invoke SetWindowLong,hButnW,12,hImageOvr
;*************************************************************************
; now lets create a STATIC window inside our new window class and set it
; to the main window class we just created. and set the "up image" into the
; static window.
;*************************************************************************
             invoke CreateWindowEx,0,
                                   addr Win_Class,NULL,
                                   WS_CHILD or WS_VISIBLE or SS_BITMAP,
                                   0,0,0,0,hButnW,ID,
                                   hModule,NULL
             mov hImage, eax
             invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageUp
             invoke SetWindowLong,hButnW,8,hImage
;*****************************************************************************
; Now notice that when we created the STATIC window we gave it not size, so
; now we will use a trick I learned to make it snap to the size of our images
; my getting the size of the STATIC window and setting the outer window to
; the STATIC windows size, this works because the STATIC window with the
; SS_BITMAP value will always snap to the size of the image set inside it so
; we can get this size and resize our outer class window to it.
;*****************************************************************************
             invoke GetWindowRect,hImage,addr WRct
             mov eax,WRct.bottom
             mov edx,WRct.top
             sub eax,edx
             mov Wheigth,eax
             mov eax,WRct.right
             mov edx,WRct.left
             sub eax,edx
             mov Wwidth,eax
             invoke SetWindowPos,hButnW,HWND_TOP,0,0,Wwidth,Wheigth,SWP_NOMOVE
;********************************************************************************
; Now we just show the window and we are done. and everyone is impressed at our
; buttons.
;********************************************************************************
             invoke ShowWindow,hButnW,SW_SHOW
             mov eax, hButnW
             ret
ImageButtonsEx endp
;**********************************************************************************
; 
;**********************************************************************************
ImageButProcs1 proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

                  LOCAL hImageUp    :DWORD
                  LOCAL hImageDwn   :DWORD
                  LOCAL hImageOvr   :DWORD
                  LOCAL hImage      :DWORD
                  LOCAL hParent     :DWORD
                  LOCAL ID          :DWORD
                  LOCAL ptX         :DWORD
                  LOCAL ptY         :DWORD
                  LOCAL bWid        :DWORD
                  LOCAL bHgt        :DWORD
                  LOCAL Rct         :RECT

    .data
    ClickFlag      dd 0
    ImageOvr       dd 0      
        .code

    .if uMsg == WM_LBUTTONDOWN
        invoke GetWindowLong,hWin,4
        mov hImageDwn, eax
        invoke GetWindowLong,hWin,8
        mov hImage, eax

        invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageDwn
        invoke SetCapture,hWin
        mov ClickFlag, 1

    .elseif uMsg == WM_MOUSEMOVE
        mov eax,sizeof TME
        mov TME.cbSize,eax
        mov eax,TME_LEAVE
        mov TME.dwFlags,eax
        mov eax,hWin
        mov TME.hwndTrack,eax

        invoke TrackMouseEvent,addr TME
        invoke GetWindowLong,hWin,12
        mov hImageOvr, eax
        .if eax != 0

        invoke GetWindowLong,hWin,8
        mov hImage, eax
        .if ImageOvr == 0
        invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageOvr
        mov ImageOvr,1
        .endif
        .endif
    .elseif uMsg == WM_MOUSELEAVE

       invoke GetWindowLong,hWin,0
       mov hImageUp, eax
       invoke GetWindowLong,hWin,8
       mov hImage, eax
       invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageUp
       mov ImageOvr,0

    .elseif uMsg == WM_LBUTTONUP

        .if ClickFlag == 0
          ret
        .else
          mov ClickFlag, 0
        .endif

        invoke GetWindowLong,hWin,0
        mov hImageUp, eax
        invoke GetWindowLong,hWin,8
        mov hImage, eax
        invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageUp
        mov ImageOvr,0
        mov eax, lParam
        cwde
        mov ptX, eax
        mov eax, lParam
        rol eax, 16
        cwde
        mov ptY, eax

        invoke GetWindowRect,hWin,addr Rct

        mov eax, Rct.right
        mov edx, Rct.left
        sub eax, edx
        mov bWid, eax

        mov eax, Rct.bottom
        mov edx, Rct.top
        sub eax, edx
        mov bHgt, eax

        cmp ptX, 0
        jle @F
        cmp ptY, 0
        jle @F
        mov eax, bWid
        cmp ptX, eax
        jge @F
        mov eax, bHgt
        cmp ptY, eax
        jge @F

        invoke GetParent,hWin
        mov hParent, eax
        invoke GetDlgCtrlID,hWin
        mov ID, eax
        invoke SendMessage,hParent,WM_COMMAND,ID,hWin

      @@:

        invoke ReleaseCapture

    .endif
    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret

ImageButProcs1 endp
.data

        Win_Class1          db "STATIC",0        
        BmpButtonClass    db "BmpButtonClass",0


.code

; ########################################################################

ImageButtonEx proc hWin:DWORD,Xpos:DWORD,Ypos:DWORD,Wwd:DWORD,Wht:DWORD,
                 Image1:DWORD,Image2:DWORD,Image3:DWORD,ID:DWORD,dwLoadFlg:DWORD


             LOCAL hImageUp    :DWORD
             LOCAL hImageDwn   :DWORD
             LOCAL hImageOvr   :DWORD
             LOCAL hImage      :DWORD
             LOCAL hModule     :DWORD
             LOCAL Wwidth      :DWORD
             LOCAL Wheigth     :DWORD
             LOCAL hButnW      :DWORD

             LOCAL WRct         :RECT
             LOCAL wc          :WNDCLASSEX

             invoke GetModuleHandle,NULL
             mov hModule, eax

             .if dwLoadFlg == 1
             invoke LoadImage,hModule,Image1,IMAGE_BITMAP,Wwd,Wht,LR_LOADFROMFILE
             mov hImageUp, eax
             invoke LoadImage,hModule,Image2,IMAGE_BITMAP,Wwd,Wht,LR_LOADFROMFILE
             mov hImageDwn, eax
             invoke LoadImage,hModule,Image3,IMAGE_BITMAP,Wwd,Wht,LR_LOADFROMFILE
             mov hImageOvr, eax
             .else
             invoke LoadImage,hModule,Image1,IMAGE_BITMAP,Wwd,Wht,0
             mov hImageUp, eax
             invoke LoadImage,hModule,Image2,IMAGE_BITMAP,Wwd,Wht,0
             mov hImageDwn, eax
             invoke LoadImage,hModule,Image3,IMAGE_BITMAP,Wwd,Wht,0
             mov hImageOvr, eax
             .endif


             mov wc.cbSize,         sizeof WNDCLASSEX
             mov wc.style,          CS_BYTEALIGNWINDOW
             mov wc.lpfnWndProc,    offset ImageButProcEx
             mov wc.cbClsExtra,     NULL
             mov wc.cbWndExtra,     20
             push hModule
             pop wc.hInstance
             mov wc.hbrBackground,  COLOR_BTNFACE+1
             mov wc.lpszMenuName,   NULL
             mov wc.lpszClassName,  offset BmpButtonClass
             mov wc.hIcon,          NULL
             invoke LoadCursor,NULL,IDC_ARROW
             mov wc.hCursor,        eax
             mov wc.hIconSm,        NULL

             invoke RegisterClassEx, ADDR wc

             invoke CreateWindowEx,WS_EX_TRANSPARENT,
                                   addr BmpButtonClass,NULL,
                                   WS_CHILD or WS_VISIBLE,
                                   Xpos,Ypos,100,100,hWin,ID,
                                   hModule,NULL

             mov hButnW, eax

             invoke SetWindowLong,hButnW,0,hImageUp
             invoke SetWindowLong,hButnW,4,hImageDwn


             invoke CreateWindowEx,0,
                                   addr Win_Class1,NULL,
                                   WS_CHILD or WS_VISIBLE or SS_BITMAP,
                                   0,0,0,0,hButnW,ID,
                                   hModule,NULL

             mov hImage, eax

             invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageUp

             invoke GetWindowRect,hImage,addr WRct
             invoke SetWindowLong,hButnW,8,hImage
             invoke SetWindowLong,hButnW,12,hImageOvr

             mov eax,WRct.bottom
             mov edx,WRct.top
             sub eax,edx
             mov Wheigth,eax

             mov eax,WRct.right
             mov edx,WRct.left
             sub eax,edx
             mov Wwidth,eax

             invoke SetWindowPos,hButnW,HWND_TOP,0,0,Wwidth,Wheigth,SWP_NOMOVE
             invoke ShowWindow,hButnW,SW_SHOW
             mov eax, hButnW

             ret

ImageButtonEx endp

; ########################################################################

ImageButProcEx proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

                  LOCAL hImageUp    :DWORD
                  LOCAL hImageDwn   :DWORD
                  LOCAL hImageOvr   :DWORD
                  LOCAL hImage      :DWORD
                  LOCAL hParent     :DWORD
                  LOCAL ID          :DWORD
                  LOCAL ptX         :DWORD
                  LOCAL ptY         :DWORD
                  LOCAL bWid        :DWORD
                  LOCAL bHgt        :DWORD
                  LOCAL Rct         :RECT


        .code

    .if uMsg == WM_LBUTTONDOWN
        invoke GetWindowLong,hWin,4
        mov hImageDwn, eax
        invoke GetWindowLong,hWin,8
        mov hImage, eax

        invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageDwn
        invoke SetCapture,hWin
        mov ClickFlag, 1

    .elseif uMsg == WM_MOUSEMOVE
        mov eax,sizeof TME
        mov TME.cbSize,eax
        mov eax,TME_LEAVE
        mov TME.dwFlags,eax
        mov eax,hWin
        mov TME.hwndTrack,eax

        invoke TrackMouseEvent,addr TME
        invoke GetWindowLong,hWin,12
        mov hImageOvr, eax
        .if eax != 0

        invoke GetWindowLong,hWin,8
        mov hImage, eax
        .if ImageOvr == 0
        invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageOvr
        mov ImageOvr,1
        .endif
        .endif
    .elseif uMsg == WM_MOUSELEAVE

       invoke GetWindowLong,hWin,0
       mov hImageUp, eax
       invoke GetWindowLong,hWin,8
       mov hImage, eax
       invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageUp
       mov ImageOvr,0

    .elseif uMsg == WM_LBUTTONUP

        .if ClickFlag == 0
          ret
        .else
          mov ClickFlag, 0
        .endif

        invoke GetWindowLong,hWin,0
        mov hImageUp, eax
        invoke GetWindowLong,hWin,8
        mov hImage, eax
        invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hImageUp
        mov ImageOvr,0
        mov eax, lParam
        cwde
        mov ptX, eax
        mov eax, lParam
        rol eax, 16
        cwde
        mov ptY, eax

        invoke GetWindowRect,hWin,addr Rct

        mov eax, Rct.right
        mov edx, Rct.left
        sub eax, edx
        mov bWid, eax

        mov eax, Rct.bottom
        mov edx, Rct.top
        sub eax, edx
        mov bHgt, eax

        cmp ptX, 0
        jle @F
        cmp ptY, 0
        jle @F
        mov eax, bWid
        cmp ptX, eax
        jge @F
        mov eax, bHgt
        cmp ptY, eax
        jge @F

        invoke GetParent,hWin
        mov hParent, eax
        invoke GetDlgCtrlID,hWin
        mov ID, eax
        invoke SendMessage,hParent,WM_COMMAND,ID,hWin

      @@:

        invoke ReleaseCapture

    .endif
    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret

ImageButProcEx endp
;**********************************************************************
;
;
;**********************************************************************
Do_MakeRegion   Proc uses esi edi ebx hWin:DWORD,hImage:DWORD,PicW:DWORD,PicH:DWORD
                LOCAL flag:DWORD
                LOCAL frun:DWORD
                LOCAL d_dc:DWORD
                LOCAL f_dc:DWORD
                LOCAL tcol:DWORD
                LOCAL _hdc:DWORD


                invoke CreateCompatibleDC,NULL
                mov _hdc,eax
                invoke SelectObject,_hdc,hImage
                mov flag,FALSE
                mov frun,TRUE
                xor edi,edi
                xor esi,esi
                invoke GetPixel,_hdc,0,0
                mov tcol,eax
_XLOOP:         invoke GetPixel,_hdc,edi,esi
                cmp eax,tcol
                jz  _LETSGO
                cmp edi,PicW
                jnz _FNDONE
_LETSGO:        cmp flag,TRUE
                jnz _NXTONE
                mov flag,FALSE
                lea eax,[esi+1]
                invoke CreateRectRgn,ebx,esi,edi,eax
                mov d_dc,eax
                cmp frun,TRUE
                jnz _NOFRUN
                mov frun,FALSE
                push d_dc
                pop f_dc
                jmp _NXTONE
_NOFRUN:        invoke CombineRgn,f_dc,f_dc,d_dc,RGN_OR
                invoke DeleteObject,d_dc
                jmp _NXTONE
_FNDONE:        cmp flag,FALSE
                jnz _NXTONE
                mov flag,TRUE
                mov ebx,edi
_NXTONE:        inc edi
                cmp edi,PicW
                jbe _XLOOP
                xor edi,edi
                inc esi
                cmp esi,PicH
                jb _XLOOP
_EXIT:          invoke SetWindowRgn,hWin,f_dc,TRUE
                invoke DeleteDC,_hdc
                ret

Do_MakeRegion   endp

end start
